/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package server;

import domain.User;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import service.ServiceUser;
import service.impl.ServiceUserImpl;
import transfer.RequestObject;
import transfer.ResponseObject;
import util.Operation;
import util.ResponseStatus;

/**
 *
 * @author student1
 */
public class Server {
    
    private ServerSocket serverSocket;
    private Socket socket;
    private final ServiceUser serviceUser;

    public Server() {
        serviceUser=new ServiceUserImpl();
    }
    
    
    
    public void start()throws Exception{
        serverSocket=new ServerSocket(9000);
        System.out.println("Waiting client");
        socket=serverSocket.accept();
        System.out.println("Client connected");
        
        handleClient();
    }

    private void handleClient() throws IOException, ClassNotFoundException {
        while(true){
            ObjectInputStream objectInputStream=new ObjectInputStream(socket.getInputStream());
            RequestObject requestObject=(RequestObject)objectInputStream.readObject();
            
            ResponseObject responseObject= handleRequest(requestObject);
            ObjectOutputStream objectOutputStream=new ObjectOutputStream(socket.getOutputStream());
            objectOutputStream.writeObject(responseObject);
        }
    }

    private ResponseObject handleRequest(RequestObject requestObject) {
        int operation=requestObject.getOperation();
        switch (operation){
            case Operation.OPERATION_LOGIN:
                return login((Map)requestObject.getData());
        }
        return null;
    }

    private ResponseObject login(Map data) {
        String username=(String) data.get("username");
        String password=(String) data.get("password");
        ResponseObject responseObject=new ResponseObject();
        try {
            User user=serviceUser.login(username, password);
            responseObject.setData(user);
            responseObject.setStatus(ResponseStatus.SUCCESS);
        } catch (Exception ex) {
            responseObject.setStatus(ResponseStatus.ERROR);
            responseObject.setErrorMessage(ex.getMessage());
        }
        
        return responseObject;
    }
}
